;
;       Converts decimal number from keyboard to hex and displays in
;       'MEM' = minus, 'TERM' clears display
;
#define DatPtr(x)       ((x)+1)         ; useful SC/MP macros
#define High(x)         ((x)/256)
#define Low(x)          ((x) & 255)

Adl     = 0Ch
Adh     = 0Eh
Ram     = 0F00h
Dispa   = 015Ah
Count   = 011h
Minus   = 012h
Ltemp   = 013h

        .org    0F50h

        ldi     0Fh                     ; added
        xpah    2
        ldi     0
        xpal    2
     
Dhex:   ldi     0
        st      Minus(2)
        st      Adl(2)
        st      Adh(2)
Disp:   ldi     High(Dispa)
        xpah    3
        ldi     Low(Dispa)-1
        xpal    3
        xppc    3
        jmp     Comd
        ldi     10
        st      Count(2)
        scl
        ld      Minus(2)
        xae
        xre
        cae
        xae
        lde
        cae
        xae
        jmp     Digit
Addd:   ld      Ltemp(2)
Digit:  ccl
        add     Adl(2)
        st      Ltemp(2)
        lde
        add     Adh(2)
        xae
        dld     Count(2)
        jnz     Addd
        lde
        st      Adh(2)
        ld      Ltemp(2)
        st      Adl(2)
        jmp     Disp
Comd:   xri     3
        jz      Dhex
        ldi     0FFh
        st      Minus(2)
        jmp     Disp
        .end
